{**********************************************************************
                PilotLogic Software House

 Package ds_Pas2JavaScript_IDE
 This file is part of CodeTyphon Studio (https://www.pilotlogic.com/)
***********************************************************************}

unit allpas2jsidereg;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,
  // LCL
  Forms, Controls,
  // BaseUtils
  LazLoggerBase,
  // IdeIntf
  ProjectIntf, ComponentEditors, LazIDEIntf, IDEOptionsIntf, IDEOptEditorIntf,
  FormEditingIntf,    
  IDECommands, MenuIntf, IDEWindowIntf,
  // Pas2js
  PJSDsgnOptions, PJSDsgnOptsFrame,
  pjsdsgnregister,

  WebCtrls,
  Pas2JS_IDE_Descriptor;


procedure Register;

implementation

{$R allpas2jsidereg.res}

uses
  frmPas2jsSWServersManager,
  pjsprojectoptions,
  pjscontroller, strpas2jsdesign, ToolbarIntf;

Const
  sPas2JSWebserverName = 'Pas2JSWebservers';

Var
  Pas2JSHTMLClassDef : TPas2JSHTMLClassDef;

type
  TPas2JSWidgetsRequirements = class(TComponentRequirements)
  public
    procedure RequiredUnits(aUnits: TStrings); override;
    procedure RequiredPkgs(aPkgs: TStrings); override;
  end;

{ TPas2JSWidgetsRequirements }

procedure TPas2JSWidgetsRequirements.RequiredUnits(aUnits: TStrings);
begin
  if ComponentClass.ClassType = TWStringGrid then begin
    aUnits.Clear;
    aUnits.Add('Grids');
  end;
end;

procedure TPas2JSWidgetsRequirements.RequiredPkgs(aPkgs: TStrings);
begin
  aPkgs.Clear;
  aPkgs.Add('js_WebWidgetsGUI');
end;

//--------------------------------------------------------------

procedure Register;

Var
  ViewCategory : TIDECommandCategory;
begin

  //==== From pjsdsgnregister ============================================================
  PJSOptions:=TPas2jsOptions.Create;
  PJSOptions.Load;
  TPJSController.Instance.Hook;
  // register new-project items
  RegisterProjectDescriptor(TProjectPas2JSWebApp.Create);
  RegisterProjectDescriptor(TProjectPas2JSNodeJSApp.Create);
  RegisterProjectDescriptor(TProjectPas2JSModuleApp.Create);
  Pas2JSHTMLClassDef:=TPas2JSHTMLClassDef.Create;
  RegisterProjectFileDescriptor(Pas2JSHTMLClassDef);

  // add IDE options frame
  PJSOptionsFrameID:=RegisterIDEOptionsEditor(GroupEnvironment,TPas2jsOptionsFrame,
                                              PJSOptionsFrameID)^.Index;

  // Add project options frame
  RegisterIDEOptionsEditor(GroupProject,TPas2JSProjectOptionsFrame, Pas2JSOptionsIndex);

  //-------------------------------
  ViewCategory:=IDECommandList.CreateCategory(nil, 'SWServers Category', 'SWServers Category', IDECmdScopeSrcEditOnly);
  if ViewCategory<>nil then
    begin

     // Windows - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     PasJSSWSDlgWindowCreator:=IDEWindowCreators.Add(cnPasJSSWSDlgWindowName,
            @CreatePasJSSWSDlgWindow,nil,
           '20%','20%','+550','+425');

     // Windows - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     ViewPasJSSWSDlgWindowCommand:=RegisterIDECommand(ViewCategory, 'SimpleWebServerManager',
           'SWServers Manager', CleanIDEShortCut, CleanIDEShortCut, nil, @ShowPasJSSWSDlgWindow);
     RegisterIDEMenuCommand(itmViewMainWindows, 'ViewSimpleWebServerManagerIDE',
           'SWServers Manager', nil, nil, ViewPasJSSWSDlgWindowCommand,'ctsimplewebserver');
   end;

  //=== From Pas2JS_IDE_Descriptor ===========================================================
  VPas2JSWForm := TPas2JSWForm.Create;
  VPas2JSWFrame := TPas2JSWFrame.Create;
  VPas2JSWDataModule := TPas2JSWDataModule.Create;

  RegisterProjectFileDescriptor(VPas2JSWForm);
  RegisterProjectFileDescriptor(VPas2JSWFrame);
  RegisterProjectFileDescriptor(VPas2JSWDataModule);

  RegisterComponentRequirements([
                                 TWPopupMenu,
                                 TWComboBox,
                                 TWListBox,
                                 TWEdit,
                                 TWMemo,
                                 TWButton,
                                 TWCheckbox,
                                 TWRadioButton,
                                 TWLabel,
                                 TWImage,
                                 TWPanel,
                                 TWTimer,
                                 TWPageControl,
                                 TWFloatEdit,
                                 TWIntegerEdit,
                                 TWDateEditBox,
                                 TWTimeEditBox,
                                 TWFileButton,  
                                 TWStringGrid,
                                 TWSplitter,
                                 TWDataGrid,
                                 TWPagination,
                                 TWWebSocketClient
                                 ], TPas2JSWidgetsRequirements);


  FormEditingHook.RegisterDesignerBaseClass(TWForm);
  FormEditingHook.RegisterDesignerBaseClass(TWFrame);
  FormEditingHook.RegisterDesignerBaseClass(TWDataModule);

  VPas2JSProject := TPas2JSProject.Create;
  RegisterProjectDescriptor(VPas2JSProject);

  //... From WebCtrls ................................................................
   RegisterComponents('jsGUI', [       
                                TWPopupMenu,
                                TWComboBox,
                                TWListBox,
                                TWEdit,
                                TWMemo,
                                TWButton,
                                TWCheckbox,
                                TWRadioButton,
                                TWLabel,
                                TWImage,
                                TWPanel,
                                TWTimer,
                                TWPageControl,
                                TWFloatEdit,
                                TWIntegerEdit,
                                TWDateEditBox,
                                TWTimeEditBox,
                                TWFileButton,   
                                TWStringGrid,
                                TWSplitter,
                                TWDataGrid,
                                TWPagination,
                                TWWebSocketClient
                                ]);

end;


end.

